 #include <QtGui>
 #include <cmath>
 #include <iostream>
 #include "cartesiano.h"
 #include "mycartesiano.h"
using namespace std;

myCartesiano::myCartesiano(){
    
    //esegue paintEvent ogni 1000 millisecondi
    QTimer *timer = new QTimer(this);
    connect(timer, SIGNAL(timeout()), this, SLOT(update()));
    timer->start(1000);

    //resetta il timer a 0
    time=new QTime;
    time->start();

    setWindowTitle(tr("Grafico"));
    resize(600, 600);
}
 

///////////////////////////////////////////////////////
///////////////////////////////////////////////////////
///////////////////////////////////////////////////////

void asse(float x0, float y0, float x1, float y1, float &m, float &q){
    m=(x0-x1)/(y1-y0);
    q=(y1+y0)/2.-m*(x1+x0)/2.;
}

int const N=2; 

//esegue il prodotto matrice M per vettore v1 : v2= M * v1
void prodN(float M[N][N], float v1[N], float v2[N]){
     for(int i=0; i<N; i++){	
        v2[i]=0.; 
        for(int j=0; j<N; j++)	
           v2[i]= v2[i] + M[i][j]*v1[j];
     }
}

//somma due vettori: v3=v1+v2
void sommaN(float v1[N], float v2[N],float v3[N]){
     for(int i=0; i<N; i++){	
        v3[i]=v2[i]+v1[i]; 
     }
}

//trasforma un punto di coordinate (x,y) in uno di coordinate (x',y')
void trasforma(float &x, float &y){
    float vin[2],vout[2],vout2[2]; 
    
    //definisco di quanto deve essere traslato il  punto lungo x e lungo y  
    float vtrasla[2]={0.1, 0.1}; 

    //ora definisco la matrice dei coefficienti della trasformazione (come visto in classe)
    // es:  M=  |1 0|    (x,y) non viene trasformato
    //          |0 1|

    // es:  M=  |2 0|    zoom x2 -> x'=2x   e y'=2y
    //          |0 2|

    // es:  M=  |-1 0|   simmetria assiale rispetto all'asse y 
    //          | 0 1|

    // es:  M=  |1  0|   simmetria assiale rispetto all'asse x 
    //          |0 -1|

    // es:  M=  |1  0|   simmetria assiale rispetto all'asse x 
    //          |0 -1|
    float M[2][2]={{0.9,0},{0,0.9}}; //modesto zoom out

    vin[0]=x;
    vin[1]=y;
    prodN(M,vin,vout);
    sommaN(vout,vtrasla,vout2);
    x=vout2[0];
    y=vout2[1];
}



///////////////////////////////////////////////////////
///////////////////////////////////////////////////////
///////////////////////////////////////////////////////


 void myCartesiano::paintEvent(QPaintEvent *)
 {
     QPainter painter(this);
     this->plot_axis();	 //disegna gli assi

     //sposta l'asse x del tempo trascorso
     //this->set_xy(x0+time->elapsed()/1000.,y0,x1+time->elapsed()/1000.,y1);
     time->restart();  //riazzera il timer 


     // set scale & x0,y0  
     painter.scale((width()) /fabs(x1-x0), -(height())/fabs(y1-y0));
     painter.translate(-x0, -y1);

    ///////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////


     static float Ax=3,Ay=-1.5,Bx=-2,By=1.5;
     float m,q;

     QLineF l1(Ax,Ay,Bx,By); //disegna un segmento 
     painter.drawLine(l1);

     asse(Ax,Ay,Bx,By,m,q);  //asse del segmento
     float Cx=-5.; 
     float Dx=5.; 
     float Cy=m*Cx+q;
     float Dy=m*Dx+q;

     QLineF l2(Cx,Cy,Dx,Dy); //disegna l'asse del segmento
     painter.drawLine(l2);

     trasforma(Ax,Ay);
     trasforma(Bx,By);

 }
